if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil"] = true;
(function(){
	dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil");
	dojo.require("com.ibm.mm.builder.iwidget.spacemanager.widget.ConfirmDialog");
	dojo.require("com.ibm.mm.builder.iwidget.spacemanager.widget.DeleteConfirmPane");
	
	var navigationUtil = com.ibm.mm.builder.utils.navigationUtil;
	var bundle = com.ibm.mm.builder.coreWidgetsStrings;
	
	var utils = {
		_dijit : null
	};
	
	utils.ui = {
		getContextRoot : function() {
			var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
			return cs.getValue(com.ibm.mashups.enabler.services.ConfigConstants.CONTEXT_ROOT_BUILDER);
		},
	
		getLoadingNodeHtml : function() {
			return [
				"<div><span><img alt='' src='",
					this.getContextRoot(), "/images/loading.gif' ></span>",
					"<span>", bundle.I_SPACE_MANAGER_LOADING, "</span>",
				"</div>"	
			].join("");
		}
	};
	utils.ui.dialog = {
		openContentDialog : function(parentNode, dijitClass, dijitOpt, dialogOpt, reference) {
			if (reference) {
				reference.show();
			}
			else {
				var dialogDiv = dojo.doc.createElement("div");
				parentNode.appendChild(dialogDiv);
				var contentDiv = dojo.doc.createElement("div");			
				dialogDiv.appendChild(contentDiv);
				var onOkFunc = function() {};
				reference = new com.ibm.mm.builder.widget.CustomDialog(dialogOpt, dialogDiv);
				var dijit = new dijitClass(dijitOpt, contentDiv);
				dijit.hide = function() {
					reference.hide();
				};
				dijit.onOk = function() {
						var func = dijit[dialogOpt.okFunc || "_ok"];
						if (dojo.isFunction(func)) {
							var d = func.apply(dijit);
							if(d){
								d.addCallback(function(data) {
									if (reference){
										reference.hide();
									}
									
									if (dojo.isFunction(dialogOpt.okCallback)) {
										dialogOpt.okCallback(data);
									}
								});
							}
							
						}
					};
				reference.show();
			}
		},
		//FIXME: the logic is wierd. We need refactor this part later.
		openConfirmDialog : function(parentNode, dijitOpt, dialogOpt, reference) {
				
			if (!utils._reference) {
				
				dialogOpt = dialogOpt || {};
				dijitOpt = dojo.mixin({}, dijitOpt, {
					context : utils.ui.getContextRoot()
				});
				var dialogDiv = dojo.create("div");
				parentNode.appendChild(dialogDiv);
				var contentDiv = dojo.create("div");			
				dialogDiv.appendChild(contentDiv);
				var onOkFunc = function() {};
				reference = new com.ibm.mm.builder.widget.CustomDialog(dialogOpt, dialogDiv);
				var dijit = new com.ibm.mm.builder.iwidget.spacemanager.widget.DeleteConfirmPane(dijitOpt, contentDiv);				

				utils._dijit = dijit;
				utils._reference = reference;
			}
			
			reference = utils._reference;
			if (utils._dijit) {
				utils._dijit.hide = function(){
					reference.hide();
				};
				utils._dijit.onOk = function(){
					var func = dialogOpt.okFunc;
					if (dojo.isFunction(func)) {
						var d = func();
						if (d) {
							d.addCallback(function(data){
								if (reference) {
									reference.hide();
								}
								if (dojo.isFunction(dialogOpt.okCallback)) {
									dialogOpt.okCallback(data);
								}
							});
						}
					}
				};
			}
			reference.show();
			dojo.query(".message", reference.domNode)[0].innerHTML = dijitOpt.message;
			reference.setTitle(dialogOpt.title);
			
			return reference;
		}
	};
	
	utils.model = {	
		getSpaceACModel : function(space) {
			if (!space) {
				return null;
			}
			return com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(space);
		},
		
		getSpaceOwner : function(space) {
			var acModel = this.getSpaceACModel(space);
			if (acModel) {
				var owner = acModel.getOwner();
				return (owner && owner.getDisplayName()) || "";
			}
			return "";
		},
		
		getSpacePageACModel : function(space, page) {
			if (!space || !page) {
				return null;
			}
			var navModel = navigationUtil.getNavigationModel();
			var layoutModel = navModel.getLayoutModel(page.getID());
			var layoutNode = layoutModel.getRoot().start();
			return com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(space, layoutNode);
		},
	
		getSpacePageOwner : function(space, page) {
			if (page && space) {
				var acModel = this.getSpacePageACModel(space, page);
				if (acModel) {
					var owner = acModel.getOwner();
					if (owner) {
						return owner.getDisplayName();
					}
				}
			}
			return "";
		},
		
		retrieveRecentSpaces: function() {
			var cookieKeyPrefix = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.CookieKey.RECENT_SPACES;
			var userId = com.ibm.mm.builder.utils.userUtil.getCurrentUser().getLoginName();
			return dojo.cookie(cookieKeyPrefix+userId);
		},
		
		storeRecentSpaces: function(recentSpacesList) {
			var cookieKeyPrefix = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.CookieKey.RECENT_SPACES;
			var userId = com.ibm.mm.builder.utils.userUtil.getCurrentUser().getLoginName();
			dojo.cookie(cookieKeyPrefix+userId, dojo.toJson(recentSpacesList));
		}
	};
	
	utils.importPage = {
		
		NLS_THEME : "//atom:link[@ext:rel='theme']",
		
		NLS_CONTENT : "//atom:entry/atom:content[@type='application/xml']",
		
		NLS_NAVIGATION_NODE : "model:navigation-node",
		
		NLS_STATIC_CONTENT_PAGE : "model:static-content-page",
		
		NLS_TITLE : "model:title",
		
		NLS_DESCRIPTION : "model:description",
		
		NLS_NLS_STRING : "base:nls-string",
		
		getResourceNS : function() {
			var serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_RESOURCE);
            var namespaces = {"atom":"http://www.w3.org/2005/Atom", "xml":"http://www.w3.org/XML/1998/namespace"};
            return dojo.delegate(serviceJson.namespaces,namespaces);
		},
		
		getResourceCollectionsUrl : function() {
			var serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_RESOURCE);
			return serviceJson.url;
		},
		
		updateTitleAndDescription : function(node, title, description, locale) {
			locale.replace(/-/g, "_");
			var ns = this.getResourceNS();
			var xpath = com.ibm.mashups.enabler.xml.XPath;
			var contents = xpath.evaluateXPath(this.NLS_CONTENT, node, ns);
			if (contents.length) {
				for (var i = 0; i < contents.length; i++) {
					var content = contents[i];
					var parentNode = null;
					var navigationNodes = xpath.evaluateXPath(this.NLS_NAVIGATION_NODE, content, ns);
					var staticContentPageNodes = xpath.evaluateXPath(this.NLS_STATIC_CONTENT_PAGE, content, ns);
					if (navigationNodes && navigationNodes.length) {
						parentNode = navigationNodes[0];
					}
					else if (staticContentPageNodes && staticContentPageNodes.length) {
						parentNode = staticContentPageNodes[0];
					}
					if (parentNode) {
						if (title !== null) {
							var titles = xpath.evaluateXPath(this.NLS_TITLE, parentNode, ns);
							var titleNode = null;
							if (titles && titles.length) {
								titleNode = titles[0];
							}
							else {
								titleNode = com.ibm.mm.enabler.utils.Dom.createElement(node, this.NLS_TITLE, ns.model);
								parentNode.appendChild(titleNode);
							}
							this._updateLocalizedElement(node, titleNode, title, locale);
						}
						if (description !== null) {
							var descriptions = xpath.evaluateXPath(this.NLS_DESCRIPTION, parentNode, ns);
							var descriptionNode = null;
							if (descriptions && descriptions.length) {
								descriptionNode = descriptions[0];
							}
							else {
								descriptionNode = com.ibm.mm.enabler.utils.Dom.createElement(node, this.NLS_DESCRIPTION, ns.model);
								parentNode.appendChild(descriptionNode);
							}
							this._updateLocalizedElement(node, descriptionNode, description, locale);
						}
					}
				}
			}
		},
		
		_updateLocalizedElement : function(xmlDoc, elementNode, text, locale) {
			var ns = this.getResourceNS();
			var xpath = com.ibm.mashups.enabler.xml.XPath;
			var xmlNsUri = "http://www.w3.org/XML/1998/namespace";
			var nlsStrings = xpath.evaluateXPath(this.NLS_NLS_STRING, elementNode, ns);
			var localeFound = false;
			if (nlsStrings && nlsStrings.length) {
				var n = nlsStrings.length;
				while (--n >= 0) {
					var lang = com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(nlsStrings[n], "xml:lang", "lang", xmlNsUri);
                	if (lang !== null && lang.replace(/-/g, "_") == locale) {
                    	com.ibm.mm.enabler.utils.Dom.textContent(nlsStrings[n], text);
                    	localeFound = true;
                   		break;
                	}
				}
			}
			if (!localeFound) {
				var ele = com.ibm.mm.enabler.utils.Dom.createElement(xmlDoc, this.NLS_NLS_STRING, ns.base);
                ele.setAttribute("xml:lang", locale);
                com.ibm.mm.enabler.utils.Dom.textContent(ele, text);	
				elementNode.appendChild(ele);	
			}
		},
	
		updateTheme: function(node,themeId){
			var ns = this.getResourceNS();
			// locate theme link
            var nodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(this.NLS_THEME, node, ns );
			var tn;
            if (nodes && nodes.length > 0) {
				tn = nodes[0]; 
            } else {
                // create link
                tn = com.ibm.mm.enabler.utils.Dom.createElement(node, "atom:link", ns.atom);

				// set theme relation
                com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(node, tn, "ext:rel", "rel", ns.ext, "theme");
                node.appendChild(tn);
            }
            // set theme uri
            var urlFactory = com.ibm.mashups.enabler.model.url.ModelUrlFactory;	
			var themeUrl = urlFactory.createModelUrl(urlFactory.THEME_URL, {});
			themeUrl.setNodes([{value : themeId, isID: true}]);
			com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(node, tn, "ext:uri", "uri", ns.ext, themeUrl.getModelURI());
			com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(node, tn, "ext:uniquename", "uniquename", ns.ext, themeId);
			tn.setAttribute("href", themeUrl.getAbsoluteURL());
		},
		
		updateParentPage : function(node, parentPageId) {
			var urlFactory = com.ibm.mashups.enabler.model.url.ModelUrlFactory;	
			var modelUrl = urlFactory.createModelUrl(urlFactory.NAVIGATION_URL, {});
			modelUrl.setNodes([{value : parentPageId, isID: true}]);
            
			var serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_RESOURCE);            
			var namespaces = {"atom":"http://www.w3.org/2005/Atom",
						"thr":"http://purl.org/syndication/thread/1.0",
						"xml":"http://www.w3.org/XML/1998/namespace",
						"opensearch":"http://a9.com/-/spec/opensearch/1.1/",
						"xhtml": "http://www.w3.org/1999/xhtml",
						"app":"http://www.w3.org/2007/app",
						"xsi":"http://www.w3.org/2001/XMLSchema-instance"};
						
            var ns = dojo.delegate(serviceJson.namespaces, namespaces);
            
                var thr = com.ibm.mashups.enabler.xml.XPath.evaluateXPath("//thr:in-reply-to", node, ns);
                if (thr && thr.length > 0) {
                    com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(node,
                        thr[0], "ext:uri", "uri", ns.ext, 
                        modelUrl.getModelURI());
                    thr[0].setAttribute("href", modelUrl.getAbsoluteURL());
                    thr[0].setAttribute("ref", modelUrl.getModelURI());
                } else {
                    thr = com.ibm.mm.enabler.utils.Utils.createNode("thr:in-reply-to", ns.thr);
                    com.ibm.mm.enabler.utils.Dom.setAttributeWithNS(node,
                        thr, "ext:uri", "uri", ns.ext, 
                        modelUrl.getModelURI());
                    node.appendChild(thr);
                    thr.setAttribute("href", modelUrl.getAbsoluteURL());
                    thr.setAttribute("ref", modelUrl.getModelURI());
                }
		},
		
		constructMultipartFormdataBody : function(textContent) {
			var boundary = "AaBbCcDdEeFf",
				content = ["--", boundary, "\r\n"];
			content.push("Content-Disposition: form-data; name=\"xmlPage\"; filename=\"test.xml\"");
				content.push("\r\n");
				content.push("Content-Type: text/xml\r\n\r\n");
				content.push(textContent);
				content.push("\r\n");
				content.push("--" + boundary + "--");
			return content.join("");	
		}
	};
	
	utils.util = {
		delayCall : function(fnObj, delay) {
			delay = delay || 0;
			return window.setTimeout(fnObj, delay);
		},
		
		parseNmIdFromResponseData : function(data){
			var serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_RESOURCE);
			var namespaces = {"atom":"http://www.w3.org/2005/Atom", "xml":"http://www.w3.org/XML/1998/namespace"};
            var ns = dojo.delegate(serviceJson.namespaces,namespaces);
			
			var nodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath("//atom:id", com.ibm.mm.enabler.utils.Dom.createDocument(data), ns );	
			return com.ibm.mm.enabler.utils.Dom.textContent(nodes[1]).split(":")[2];
		},
		
		parseResourceIdFromResponseData : function(data){
			var serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_RESOURCE);
			var namespaces = {"atom":"http://www.w3.org/2005/Atom", "xml":"http://www.w3.org/XML/1998/namespace"};
            var ns = dojo.delegate(serviceJson.namespaces,namespaces);
			
			if (dojo.isString(data)) {
				data = com.ibm.mm.enabler.utils.Dom.createDocument(data);
			}
			var id = com.ibm.mashups.enabler.xml.XPath.evaluateString("//atom:id", data , ns);
			return id ? id.split(":")[2] : "";
		}
	};
	
	dojo.setObject("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil", utils);
	
})();

}
