if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.PageItem"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.PageItem"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.widget.PageItem");
dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.PageItem", 
		[dijit._Widget, dijit._Templated], {
	pageMeta : {},		
			
	templatePath : dojo.moduleUrl("com.ibm.mm.builder", "iwidget/spacemanager/widget/templates/PageItemTemplate.html"),			
	
	constructor : function() {
		this._bundle = com.ibm.mm.builder.coreWidgetsStrings;
		this.navigationUtil = com.ibm.mm.builder.utils.navigationUtil;
		this.enablerUtil = com.ibm.mm.builder.utils.enablerUtil;
		this.spaceManagerUtil = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil;
		this._constants = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants;
		this.spaceUtil = com.ibm.mm.builder.utils.spaceUtil;
		this.pageUtil = com.ibm.mm.builder.utils.pageUtil;
	},
			
	postMixInProperties : function() {
		this.pageInfo = {
			pageId : this.pageMeta.pageId,
			title : "",
			description : "",
			info : !!this.pageMeta.owner ? dojo.string.substitute(this._bundle.I_SPACE_MANAGER_PAGE_INFO, [this.pageMeta.owner]) : ""
		};
		dojo.mixin(this, this._bundle);
		this.space = this.pageMeta.space;
		this.page = this.pageMeta.page;
		this.pageId = this.page.getID();
		this.spaceId = this.space.getID();
		this.parentPageId = this.pageUtil.getParentPageId(this.pageId);
		this.level = this.pageMeta.level;
	},	
	
	truncateIfTooLong: function(str, len){
		if (str && str.length > len) {
			return str.substring(0, len - (this.pageMeta.level - 1) * 3) + "...";
		}
		return str;
	},
	transformDescriptionForXss: function(node){
		var text = node ? node : this.pageMeta.description;
		var textNode = dojo.doc.createTextNode(com.ibm.mm.builder.utils.htmlUtil.unEscapeString(text));
		var parentNode = dojo.query(".description", this.domNode)[0];
		parentNode.innerHTML = "";
		parentNode.appendChild(textNode);
		
		var titleAttr = dojo.doc.createAttribute("title");
		titleAttr.nodeValue = this.pageMeta.description;
		parentNode.setAttributeNode(titleAttr);
		
		//truncate
		var _self = this;
		setTimeout(function(){
			_self.truncateNodeText(parentNode, 370, "title", {fontSize:"12px"});
		},0);
	},
	
	transformTitleForXss: function(node){
		var text = node ? node : this.pageMeta.title;
		var textNode = dojo.doc.createTextNode(com.ibm.mm.builder.utils.htmlUtil.unEscapeString(text));
		var parentNode = dojo.query(".title", this.domNode)[0];
		parentNode.innerHTML = "";
		parentNode.appendChild(textNode);
		
		var titleAttr = dojo.doc.createAttribute("title");
		titleAttr.nodeValue = this.pageMeta.title;
		parentNode.setAttributeNode(titleAttr);
		
		//truncate
		var _self = this;
		setTimeout(function(){
			_self.truncateNodeText(parentNode, 370, "title", {fontSize:"14px"});
		},0);
	},
	
	truncateNodeText : function(/* DomNode */node, widthLimit, /* String */tipField, /*obj */fontStyle){
		var	textField = (node.tagName.toLowerCase() === "input") ? "value" : "innerHTML";
		if(!tipField){
			tipField = "title";
		}
		widthLimit -= 30*(this.pageMeta.level-1);
		var str = dojo.string.trim(node[textField]);
		if(str.length === 0 ){return;}
		if (widthLimit > 0) {
			var shortStr = com.ibm.mm.builder.utils.htmlUtil.getStrWithLimit(str, node, widthLimit,fontStyle);
			if(shortStr.length <= str.length + 2 && !dojo.hasAttr(node,tipField)){
				dojo.attr(node,tipField,com.ibm.mm.builder.utils.htmlUtil.unEscapeString(str));
			}		
			node[textField] = (textField === "innerHTML" && (!dojo.hasAttr(node,"keepBlankSpace"))) ? com.ibm.mm.builder.utils.htmlUtil.formatBlankSpace(shortStr) : shortStr;
		}
	},
	
	destroy: function() {
		if (this._actionsWidget) {
			this._actionsWidget.destroy();
			delete this._actionsWidget;
			this._actionsWidget = null;
		}
			
		if (this._togglerWidget) {
			this._togglerWidget.destroy();
			delete this._togglerWidget;
			this._togglerWidget = null;
		}
			
		if (this._actionsNode) {
			delete this._actionsNode;
			this._actionsNode = null;
		};
		this.inherited(arguments);
	},
	
	postCreate : function() {
		this.transformTitleForXss();
		this.transformDescriptionForXss();
		if (this.page) {
			var spaceItem = {"id":this.space.getID(), "title": this.enablerUtil.getNodeTitle(this.space) || ""};
			
			this.connect(this._titleNode, "onclick",  function() {
				dojo.publish(this._constants.Topic.Space.addToRecentSpaces, [spaceItem]);
				dojo.publish(this._constants.Topic.Space.switchPage, [this.pageId]);
			});
			this.connect(this._titleNode, "onkeypress",  function(evt) {
				if (evt.keyCode != dojo.keys.ENTER) {
					return;
				}
				dojo.publish(this._constants.Topic.Space.addToRecentSpaces, [spaceItem]);
				dojo.publish(this._constants.Topic.Space.switchPage, [this.pageId]);
				
				evt.preventDefault();
			});
			this.refreshActionsMenu();	
			this.spaceManagerUtil.util.delayCall(dojo.hitch(this, this._showToggle), 100);
		}
		if (this.pageMeta.level) {
			dojo.style(this._intentNode, "width", (this.pageMeta.level * 30) + "px");
			var _mainNodeWidth = dojo.coords(this.domNode).w - (this.pageMeta.level * 30) - 122; //calculate the relative width of main node(including possible scrollbar)
			if (_mainNodeWidth > 0){
				dojo.style(this._mainNode, "width", _mainNodeWidth + "px");
			}
		}
		dojo.create("img", {"src": builderConfig.builderPath + "/images/spacemanager/page.gif", "alt": ""}, this._iconNode);
	},

	_showToggle : function() {
		if (!this.page) {
			return;
		}
		var navMode = this.navigationUtil.getNavigationModel();
		// never do this if you only need to know if the node HAS children
		//var iterator = navMode.getChildren(this.page);
		//if (iterator.hasNext()) {
		if (navMode.hasChildren(this.page)) {
			this._togglerWidget = new com.ibm.mm.builder.iwidget.spacemanager.widget.Toggler({"boundNode" : this._pagesNode, "parentPage": this.page, "space": this.space, "level": this.pageMeta.level}, this._togglerNode);
		}
	},
	
	refreshActionsMenu : function(){
		var actionsNode = null;
		
		if(!this._actionsWidget){
			actionsNode = this._actionsNode;
		}else{
			actionsNode = dojo.create("div",{},this._actionsNode,"before");
			this._actionsWidget.destroyRecursive();
			delete this._actionsWidget;
		}		
		this._actionsWidget = new com.ibm.mm.builder.iwidget.spacemanager.widget.ActionsMenu({pageId : this.pageId}, actionsNode);
		this._actionsNode = this._actionsWidget.domNode;
	}, 
	
	show : function(){
		this.refreshActionsMenu();
		this._refreshHiddenInfo();
	},
	
	hide: function(){
		this.refreshActionsMenu();
		this._refreshHiddenInfo();
	},
	
	remove: function(){
		var navMode = this.navigationUtil.getNavigationModel();
		var parentPageNodes = dojo.query(".dijitVisible [page_id='"+this.parentPageId+"']");
		var iterator = null;
		var count;
		
		if(parentPageNodes.length === 0){ //remove page from space				
			var space = this.spaceUtil.getSpaceNode(this.spaceId);				
			var rootNodeId = space.getRootNavigation();		
			var rootPage = navMode.find(rootNodeId).start();
			if (rootPage) {
				var hasPages = navMode.hasChildren(rootPage);	
				var spaceNode;				
				if(!hasPages){
					spaceNode = dojo.query(".dijitVisible [space_id='"+this.spaceId+"']")[0];
					
					if(dijit.byNode(spaceNode)._togglerWidget){
						dojo.create("div", {	"class":"toggler", "dojoattachpoint": "_togglerNode", innerHTML: " "},dijit.byNode(spaceNode)._togglerWidget.domNode,"before");
						dijit.byNode(spaceNode)._togglerWidget.destroyRecursive();
						dijit.byNode(spaceNode)._togglerWidget  = null;
					}
				}
				if(this._constants.showPagesCount === "true"){		
					count = 0;	
					iterator = navMode.getChildren(rootPage);
					count = iterator.size().start();											
					var info = dojo.string.substitute(this._bundle.I_SPACE_MANAGER_SPACE_INFO, [com.ibm.mm.builder.utils.acModelUtil.getSpaceOwner(this.spaceId).getDisplayName(), count]);
					if (spaceNode) {
						dojo.query(".info", spaceNode)[0].innerHTML = info;
					}
				}
			}
		}else{
			var parentPage = this.pageUtil.getPageNode(this.parentPageId);
			if (parentPage) {
				iterator = this.navigationUtil.getNavigationModel().getChildren(parentPage);		
				count = iterator.size().start();
				if(count === 0){
					var parentPageNode = dojo.query(".dijitVisible [page_id='"+this.parentPageId+"']")[0];
					if(dijit.byNode(parentPageNode)._togglerWidget){
						dojo.create("div", {	"class":"toggler", "dojoattachpoint": "_togglerNode", innerHTML: " "},dijit.byNode(parentPageNode)._togglerWidget.domNode,"before");
						dijit.byNode(parentPageNode)._togglerWidget.destroyRecursive();
						dijit.byNode(parentPageNode)._togglerWidget  = null;
					}
				}
			}
		}
		this.destroyRecursive();
	},
	
	_refreshHiddenInfo : function(){
		if(this.page.isHidden()){
			dojo.addClass(this.domNode, "hidden_page");
			dojo.addClass(this._flagNode, "hidden_flag");
		}else{
			dojo.removeClass(this.domNode, "hidden_page");
			dojo.removeClass(this._flagNode, "hidden_flag");
		}	
	},
	
	refresh : function(){
		this.page = com.ibm.mm.builder.utils.pageUtil.getPageNode(this.pageId);
		this._refreshTitle();
		this._refreshDescription();
		this._refreshIcon();
		this._refreshHiddenInfo();
		this._refreshToggler();		
	},
	
	_refreshTitle : function(){
		var pageTitle = this.enablerUtil.getNodeTitle(this.page) || this._bundle.I_SPACE_MANAGER_NO_TITLE;
		this.transformTitleForXss(pageTitle);
	},
	
	_refreshDescription : function(){
		var pageDescription = this.enablerUtil.getNodeDescription(this.page) || this._bundle.I_SPACE_MANAGER_NO_DESCRIPTION;
		this.transformDescriptionForXss(pageDescription);
	},
	
	_refreshIcon : function(){
		
	},
	
	_refreshToggler : function(){
		
		var navMode = this.navigationUtil.getNavigationModel();		
		var hasPages = navMode.hasChildren(this.page);
		if (hasPages) {
			var togglerNode = this._togglerNode;
			this._pagesNode = dojo.query(".pages", this.domNode)[0];
			if (!this._togglerWidget) {
				this._togglerWidget = new com.ibm.mm.builder.iwidget.spacemanager.widget.Toggler({"boundNode" : this._pagesNode, "parentPage": this.page, "space": this.space, "level": this.pageMeta.level}, togglerNode);
				this._togglerNode = this._togglerWidget.domNode;
			}	
		} else {
			if (this._togglerWidget) {
				this._togglerWidget.destroy();
				this._togglerWidget = null;
			}
		}
		
		
	},
	
	move: function(targetPageId, position){
	
		var pageNodes = dojo.query(".dijitVisible [page_id='"+targetPageId+"']");
	
		if(pageNodes.length > 0){
			var targetPageItem = dijit.byNode(pageNodes[0]);
			this._moveToPage(targetPageItem, position);
		}else{
			var spaceNodes = dojo.query(".dijitVisible [space_id='"+this.spaceId+"']");
			var spaceItem = dijit.byNode(spaceNodes[0]);
			this._moveToSpace(spaceItem);
		}
		
		this.destroyRecursive();
	},
	
	_moveToSpace: function(spaceItem){
		
		var rootNode = this.navigationUtil.getNavigationRootNode(this.spaceId);
		
		var spaceNode = spaceItem.domNode;
		var pagesNode = dojo.query(".pages", spaceNode)[0];
		var newPageNode = dojo.create("div", {}, pagesNode);
		
		var pageOwner = "";
		var _self = this;
		if (this._constants.showPageOwner === "true") {
			pageOwner = this.spaceManagerUtil.model.getSpacePageOwner(this.space, this.page);
		}
		var newPageItem = new com.ibm.mm.builder.iwidget.spacemanager.widget.PageItem({
		pageMeta: {
			title: _self.enablerUtil.getNodeTitle(this.page) || _self._bundle.I_SPACE_MANAGER_NO_TITLE,
			description: _self.enablerUtil.getNodeDescription(this.page) || _self._bundle.I_SPACE_MANAGER_NO_DESCRIPTION,
			owner: pageOwner,
			level: 1,
			space: _self.spaceUtil.getSpaceNode(this.spaceId),
			page: this.page,
			pageId: this.pageId
		}
		}, newPageNode);
		
		if(this.page.isHidden()){
			dojo.addClass(newPageItem.domNode, "hidden_page");
			dojo.addClass(newPageItem._flagNode, "hidden_flag");
		}
		
		var parentPage = this.pageUtil.getParentPageNode(this.pageId);
		if(!(spaceItem._togglerWidget)){
			spaceItem._togglerWidget = new com.ibm.mm.builder.iwidget.spacemanager.widget.Toggler({"boundNode" : pagesNode, "parentPage": parentPage, "space": this.space, "level": 0}, dojo.query(".toggler", spaceNode)[0]);
		}
		
		var navMode = this.navigationUtil.getNavigationModel();
		
		var rootNodeId = this.space.getRootNavigation();
		// tactical solution to get updated root node; a more general
		// invalidation framework will be in place later on
		navMode.invalidate(rootNodeId);
		
	
		if(this._constants.showPagesCount === "true"){
			var count = 0;
			var rootPage = navMode.find(rootNodeId).start();
			if (rootPage) {
				var iterator = navMode.getChildren(rootPage);
				count = iterator.size().start();
			}
			var info = dojo.string.substitute(_self._bundle.I_SPACE_MANAGER_SPACE_INFO, [com.ibm.mm.builder.utils.acModelUtil.getSpaceOwner(this.spaceId).getDisplayName(), count]);
			dojo.query(".info", spaceNode)[0].innerHTML = info;
		}
		
	},
	
	_moveToPageAsSibling: function(targetPageItem, position){
	
		var targetPageNode = targetPageItem.domNode;		
		var newPageNode = dojo.create("div", {}, targetPageNode, position==="previous"? "before" : "after");
		var pageOwner = "";
		if (this._constants.showPageOwner === "true") {
			pageOwner = this.spaceManagerUtil.model.getSpacePageOwner(this.space, this.page);
		}
		var _self = this;
		var newPageItem = new com.ibm.mm.builder.iwidget.spacemanager.widget.PageItem({
			pageMeta: {
				title: _self.enablerUtil.getNodeTitle(this.page) || _self._bundle.I_SPACE_MANAGER_NO_TITLE,
				description: _self.enablerUtil.getNodeDescription(this.page) || _self._bundle.I_SPACE_MANAGER_NO_DESCRIPTION,
				owner: pageOwner,
				level: targetPageItem.level,
				space: this.space,
				page: this.page,
				pageId: this.pageId
			}
		}, newPageNode);
		
		if(this.page.isHidden()){
			dojo.addClass(newPageItem.domNode, "hidden_page");			
			dojo.addClass(newPageItem._flagNode, "hidden_flag");
		}	
			
	},
	
	_moveToPageAsChild: function(targetPageItem){
	
		var parentPageNode = targetPageItem.domNode;
		var pagesNode = dojo.query(".pages", parentPageNode)[0];
		var newPageNode = dojo.create("div", {}, pagesNode);
		
		var pageOwner = "";
		if (this._constants.showPageOwner === "true") {
			pageOwner = this.spaceManagerUtil.model.getSpacePageOwner(this.space, this.page);
		}
		
		var _self = this;
		var newPageItem = new com.ibm.mm.builder.iwidget.spacemanager.widget.PageItem({
			pageMeta: {
				title: _self.enablerUtil.getNodeTitle(this.page) || _self._bundle.I_SPACE_MANAGER_NO_TITLE,
				description: _self.enablerUtil.getNodeDescription(this.page) || _self._bundle.I_SPACE_MANAGER_NO_DESCRIPTION,
				owner: pageOwner,
				level: targetPageItem.level + 1,
				space: this.space,
				page: this.page,
				pageId: this.pageId
			}
		}, newPageNode);
		
		var parentPage = this.pageUtil.getParentPageNode(this.pageId);
					
		if(this.page.isHidden()){
			dojo.addClass(newPageItem.domNode, "hidden_page");			
			dojo.addClass(newPageItem._flagNode, "hidden_flag");
		}	
		
		if(!(targetPageItem._togglerWidget)){
			targetPageItem._togglerWidget = new com.ibm.mm.builder.iwidget.spacemanager.widget.Toggler({"boundNode" : pagesNode, "parentPage": parentPage, "space": this.space, "level": targetPageItem.level}, dojo.query(".toggler", parentPageNode)[0]);
		}
		// tactical solution to get updated root node; a more general
		// invalidation framework will be in place later on
		var navMode = this.navigationUtil.getNavigationModel();			
		navMode.invalidate(parentPage);
	},
	
	_moveToPage: function(targetPageItem, position){
		if(position !=="children"){ //move to next or previous
			this._moveToPageAsSibling(targetPageItem, position);
		}else{//move as a child
			this._moveToPageAsChild(targetPageItem);
		}	
	},
	
	createSubPage: function(page){
		var _self = this;
		var pagesNode, pageItem, newPageNode, pageOwner, navMode;
		var parentPageNode = this.domNode;
		pagesNode = dojo.query(".pages", parentPageNode)[0];
		newPageNode = dojo.create("div", {}, pagesNode);
		pageOwner = "";
		if (this._constants.showPageOwner === "true") {
			pageOwner = this.spaceManagerUtil.model.getSpacePageOwner(this.space, page);
		}
			
		pageItem = new com.ibm.mm.builder.iwidget.spacemanager.widget.PageItem({
			pageMeta: {
				title: _self.enablerUtil.getNodeTitle(page) || _self._bundle.I_SPACE_MANAGER_NO_TITLE,
				description: _self.enablerUtil.getNodeDescription(page) || _self._bundle.I_SPACE_MANAGER_NO_DESCRIPTION,
				owner: pageOwner,
				level: this.level + 1,
				space: this.space,
				page: page,
				pageId: page.getID()
			}
		}, newPageNode);
		
		if(page.isHidden()){
			dojo.addClass(pageItem.domNode, "hidden_page");
			dojo.addClass(pageItem._flagNode, "hidden_flag");
		}
		
		if(!(this._togglerWidget)){
			this._togglerWidget = new com.ibm.mm.builder.iwidget.spacemanager.widget.Toggler({"boundNode" : pagesNode, "parentPage": this.page, "space": this.space, "level": this.level}, dojo.query(".toggler", parentPageNode)[0]);
		}
		
		// tactical solution to get updated root node; a more general
		// invalidation framework will be in place later on
		navMode = _self.navigationUtil.getNavigationModel();			
		navMode.invalidate(this.page);

	}
	
});

}
