if(!dojo._hasResource["com.ibm.mm.builder.utils.PageWidthChanger"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.utils.PageWidthChanger"] = true;
dojo.provide("com.ibm.mm.builder.utils.PageWidthChanger");

dojo.declare("com.ibm.mm.builder.utils.PageWidthChanger", null, {

	constructor : function() {
		this._changer = new com.ibm.mm.builder.utils.PageWidthChanger.Changer();
		this._pageWidthMode = {};
		if (dojo.isIE == 6) {
			this._resizeFn = dojo.hitch(this, this._resizeHandler);
			window.attachEvent("onresize", this._resizeFn);
		}
	},	
	
	setWidthRangeProvider : function(provider) {
		this._wrp = provider;
	},
	
	setWidgetListProvider : function(provider) {
	    this._wlp = provider;
	},
	
	setPageWidthModeProvider : function(provider) {
		this._pwmp = provider;
	},
	
	init : function() {
		this._pageWidthMode = this.getPageWidthMode();
	},
	
	addPageWidthModeChangedListener : function(listener) {
		this._pwmcListener = listener;
	},
	
	getPageWidthRange : function() {
		return {
			min : this._wrp.getMinimum(),
			max : this._wrp.getMaximum()
		};
	},
	
	_getBodyWidthToFitViewport : function() {
		var d = this._getViewportDimension();
		var delta = dojo.marginBox(dojo.body()).w - dojo.contentBox(dojo.body()).w;
		return d.width - delta - 23;
	},
	
	changeWidthToFitViewport : function(minWidth) {
		var d = this._getViewportDimension();
		var delta = dojo.marginBox(dojo.body()).w - dojo.contentBox(dojo.body()).w;
		/*var fluidWidth = d.width - delta - 60;
		dojo.style(dojo.query("html")[0], {
			"width" : (d.width - delta) + "px"
		});
		this._changer.setWidth(fluidWidth);*/
		this.useFluidLayout(minWidth);
		//this._changer.setOverflow();
	},
	
	useFluidLayout : function(minWidth) {
		this._changer.restoreToFluidLayout();
		if (minWidth) {
			var min = Math.max(parseInt(minWidth,10), this._wrp.getMinimum());
			this.setMinimumWidth(min);
		}
	},
	
	_getViewportDimension : function() {
	  var w = window.innerWidth || (document.documentElement && document.documentElement.clientWidth) || document.getElementsByTagName('body')[0].clientWidth;
	  var h = window.innerHeight || (document.documentElement && document.documentElement.clientHeight) || document.getElementsByTagName('body')[0].clientHeight;
	  return {width : w, height : h};
	},
	
	changeWidth : function(width) {
	    var minWidth = this._pageWidthMode.mode == "dynamic" ? this._getBodyWidthToFitViewport() : 0;
		var viewportWidth = this._getBodyWidthToFitViewport();
		//var min = Math.max(this._wrp.getMinimum(), minWidth), max = this._wrp.getMaximum();
		var min = Math.min(this._wrp.getMinimum(), this._wrp.getMaximum()) , max = this._wrp.getMaximum();
		width = Math.min(Math.max(width, min), max);
		if (this._pageWidthMode.mode == "dynamic") {
			width = width < viewportWidth ? "auto" : width;
		}
		this._changer.changeTo(width, min, max);
	},
	
	changeWidthDelta : function(delta) {
	    var oldX = this._changer.getWidth();
		this.changeWidth(oldX + delta);
	},
	
	setMinimumWidth : function(width) {
		this._changer.setMinimum(width);
	},

	
	_normalizeWidgetId : function(widgetId) {
	   return  widgetId.indexOf(com.ibm.mm.builder.constant.skinIdPrefix) === 0 ? widgetId : com.ibm.mm.builder.constant.skinIdPrefix + widgetId;
	},
	
	_getMinimumWidthForWidgets : function(widgetIds) {
	  widgetIds = widgetIds || this._wlp.getWidgetIds() || [];
	  var rightPos = dojo.map(widgetIds, function(widgetId) {
	   var box = dojo.marginBox(dojo.byId(this._normalizeWidgetId(widgetId)));
			return box.l + box.w;
	  }, this);
	  var min = 0;
	  dojo.forEach(rightPos, function(value) {
		  min = Math.max(min, value);
	  });
	  return min;
	},
	
	_getWidgetMarginBox : function(widgetId) {
	    widgetId = this._normalizeWidgetId(widgetId);
	    return dojo.marginBox(dojo.byId(widgetId));
	},
	
	_isWidthInViewport : function(width) {
		var d = this._getViewportDimension();
		var delta = dojo.marginBox(dojo.body()).w - dojo.contentBox(dojo.body()).w;
		var fluidWidth = d.width - delta - 60;
		return width < fluidWidth;
	},
	
	getPageWidthMode : function() {
	    return (this._pwmp && this._pwmp.getPageWidthMode && this._pwmp.getPageWidthMode()) || {};
	},
	
	setPageWidthMode : function(pageWidthMode) {
		if (pageWidthMode.mode !== this._pageWidthMode.mode || 
			parseInt(pageWidthMode.width,10) !== parseInt(this._pageWidthMode.width,10)) {
			this._pageWidthMode = pageWidthMode;
			
			var payload = {
				"type" : "change",
				"summary" : {
				   "old" : dojo.clone(this._pageWidthMode),
				   "new" : dojo.clone(pageWidthMode)
				}
			};
			if (this._pwmcListener) {
				if (dojo.isFunction(this._pwmcListener)) {
				   this._pwmcListener(payload);
				}
				else if (dojo.isObject(this._pwmcListener)) {
					this._pwmcListener.fn.apply(this._pwmcListener.scope || dojo.global, [payload]);
				}
			}
		}
	},
	
	hasReactionToWidget : function() {
	   return this._pageWidthMode.mode == "dynamic";
	},
	
	_needsToAdjustWidth : function() {
		return this._pageWidthMode.mode == "dynamic";
	},
	
	_changeWidthAndScroll : function(width, left) {
		this.changeWidth(width);
		this._changer.scrollToView(left);
	},

	widgetToBeResized : function(widgetId, width, deltaW) {
	    if (!this.hasReactionToWidget()) {
			return;
		}
		//this._changer.cancelOverflow();
		/*if (deltaW < 0) {
			var box = this._getWidgetMarginBox(widgetId);
			if (box.l + width > this._changer.getWidth()) {
			  this.changeWidth(box.l + width);
			  this._changer.scrollToView(box.l);
			}
		}*/
		var box = this._getWidgetMarginBox(widgetId);
		this.changeWidth(box.l + width);
		this._changer.scrollToView(box.l);
	},
	
	widgetToBeMoved : function(widgetId, left, width) {
	   if (!this.hasReactionToWidget()) {
			return;
		}
		if (typeof left == "undefined" || left === null) {
			throw new Error("Please provide the left coordinate.");
		}
		if (typeof width == "undefined" || width === null) {
			if (widgetId) {
				var box = this._getWidgetMarginBox(widgetId);
				width = box.w;
			}
			else {
				throw new Error("Please provide the widget id or width.");
			}
		}
		//this._changer.cancelOverflow();
		
		this.changeWidth(left + width);
		this._changer.scrollToView(left);
	},
	
	
	widgetToBeRemoved : function() {
	   if (!this.hasReactionToWidget()) {
			return;
	   }
	   var widgetIds = this._wlp.getWidgetIds();
	   var min = this._getMinimumWidthForWidgets(widgetIds);
	   this.changeWidth(min);
	},
	
	_resizeHandler : function() {
		if (!this._needsToAdjustWidth()) {
			return;
		}
		window.detachEvent("onresize", this._resizeFn);
		this._clearWidthChangerTimeout();
		this._widthChangerTimeout = window.setTimeout(dojo.hitch(this, this._changeMinMaxWidth), 300);
		window.attachEvent("onresize", this._resizeFn);
	},
	
	_changeMinMaxWidth : function() {
		var min = this._wrp.getMinimum();
		var max = this._wrp.getMaximum();
		this._changer._changeMinMaxWidth(min, max);
		this._clearWidthChangerTimeout();
	},
	
	_clearWidthChangerTimeout : function() {
		if (this._widthChangerTimeout) {
			window.clearTimeout(this._widthChangerTimeout);
		}
	}
	
});


dojo.declare("com.ibm.mm.builder.utils.PageWidthChanger.Changer", null, {
	WIDTH_CHANGE_THROTTLE_VALUE : 50,
	
	constructor : function() {
		this._node = dojo.body();
		this._toChangeWidthTimer = null;
	},
	
	_getNode : function() {
		return this._node;
	},
	
	_changeMinMaxWidth : function(min, max) {
		var currentWidth = document.documentElement.clientWidth;
		var newWidth = currentWidth < min ? min : (currentWidth > max ? max : currentWidth);
		if (newWidth == min || newWidth == max) {
			this.setWidth(newWidth);
		}
		else {
			this.setWidth("auto");
		}
	},
	
	changeTo : function(/* Number */ width, min, max) {
		//this._clearChangeToTimer();
		//this._toChangeWidthTimer = window.setTimeout(dojo.hitch(this, this._doChangeTo, width, min, max),this.WIDTH_CHANGE_THROTTLE_VALUE);
		this._doChangeTo(width, min, max);
	},
	
	_clearChangeToTimer : function() {
		if (this._toChangeWidthTimer) {
			window.clearTimeout(this._toChangeWidthTimer);
		}
	},
	
	_normalizeNumericValues : function(value) {
		if (value || value === 0) {
			var v = /^\d+$/.test(value + "") ? (value + "px") : value;
			return v;
		}
	},
	
	_hackForShadowMenu : function() {
		dojo.query(".mashupsShadowNode").style("left", 0);
	},
	
	_doChangeTo : function(width, min, max) {
		var obj = {};
		var w = this._normalizeNumericValues(width);
		if (w) {
			obj.width = w;
		}
		var minW = this._normalizeNumericValues(min);
		if (minW) {
			obj.minWidth = minW;
		}
		var maxW = this._normalizeNumericValues(max);
		if (maxW) { 
			obj.maxWidth = maxW;
		}
		dojo.style(this._getNode(), obj);
		this._hackForShadowMenu();
	},
	
	setMinimum : function(width) {
	    this._doChangeTo(null, width);
	},
	
	setWidth : function(width) {
		this._doChangeTo(width);
	},
	
	getWidth : function() {
	  return dojo.style(this._getNode(), "width");
	},
	
	setOverflow : function() {
		dojo.style(dojo.query("html")[0], {
			"overflowX" : "hidden"
		});
		window.scrollTo(0, window.pageYOffset);
	},
	
	cancelOverflow : function() {
		dojo.style(dojo.query("html")[0], {
			"overflowX" : "auto"
		});
	},
	
	scrollToView : function(xPos) {
		//window.scrollTo(xPos, window.pageYOffset);
	},
	
	restoreToFluidLayout : function() {
		var maxWidth = dojo.isIE ? "100%" : "auto";
		this._doChangeTo("auto", "auto", "100%");
	}
});

if (!dojo.isObject("com.ibm.mm.builder.utils.pageWidthChanger")) {
	dojo.setObject("com.ibm.mm.builder.utils.pageWidthChanger", new com.ibm.mm.builder.utils.PageWidthChanger());
}

}
