/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.require("com.ibm.mm.builder.utils.embedUtil");
dojo.require("com.ibm.mm.builder.dialog.EmbeddingWidgetDialog");
dojo.require("com.ibm.mm.builder.utils.toolboxUtil");
dojo.require("com.ibm.mm.builder.iwidget.SystemWidget");

dojo.declare("com.ibm.mm.builder.embedWidget",com.ibm.mm.builder.iwidget.SystemTemplatedWidget,{	

	embedWidgetDlg:null,
	updateMarkupConnectors:[],
	
    onLoad: function() {
		var widgetId = this.iContext.widgetId;
		this.embedWidgetDlg = new com.ibm.mm.builder.dialog.EmbeddingWidgetDialog("_" + widgetId + "_embedding_div", widgetId);
	},
	onUnload:function(){
		for (var i=0;i<this.updateMarkupConnectors.length;i++){
			dojo.disconnect(this.updateMarkupConnectors[i]);
		}
		dojo.disconnect(this.loadEditModeConector);
	},
	onView: function(){
		this.inherited(arguments);
		if (dojo.isSafari) {	//Setting radio checked in embedWidget.xml doesn't work on Safari
			this.emdPgWidth.click();
			this.emdPgScrollOn.click();
		}
		this.updateMarkupConnectors.push(dojo.connect(this.emdPgWidth,"change",this.embedWidgetDlg,"updateMarkup"));
        this.updateMarkupConnectors.push(dojo.connect(this.emdPgAutoWidth,"change",this.embedWidgetDlg,"updateMarkup"));
	    this.updateMarkupConnectors.push(dojo.connect(this.emdPgScrollOn,"change",this.embedWidgetDlg,"updateMarkup"));
		this.updateMarkupConnectors.push(dojo.connect(this.emdPgScrollOff,"change",this.embedWidgetDlg,"updateMarkup"));
		this.updateMarkupConnectors.push(dojo.connect(this.embedPgDlgWidthInput,"change",this.embedWidgetDlg,"updateMarkup"));
		this.updateMarkupConnectors.push(dojo.connect(this.embedPgDlgHeightInput,"change",this.embedWidgetDlg,"updateMarkup"));
	},
	
	onEmbedWidget: function(iEvent){
		// First, create a widget instance markup
		var widgetDefId = iEvent.payload;
		var newWidgetId = com.ibm.mm.builder.utils.embedUtil.createEmbeddingWidgetMarkup(widgetDefId);
		
		// Second, call live text to parse dom
		var widgetPlaceHolder = dojo.byId("Embedding_Widget_TmpDiv");
		var widgetMD = com.ibm.mm.builder.utils.toolboxUtil.getWidgetDefinition(widgetDefId);
		
		dojo.publish("/com/ibm/mashups/livetext/livetextchanged",[widgetPlaceHolder]);
		
		if(!this.embedWidgetDlg.dialogContainer){
			if(typeof this.iContext.dialogContainer !== undefined && this.iContext.dialogContainer !== null){
				this.embedWidgetDlg.dialogContainer = this.iContext.dialogContainer;
				var originHideFunc = dojo.hitch(this.embedWidgetDlg.dialogContainer, this.embedWidgetDlg.dialogContainer.trueHide);
				var _this = this;
				this.embedWidgetDlg.dialogContainer.trueHide = dojo.hitch(this.embedWidgetDlg.dialogContainer, function(){
					originHideFunc();
					_this.embedWidgetDlg.destroyEmbeddedWidget();
				});		
			}	
		}
		
		// Third, update title and icon
		com.ibm.mm.builder.utils.iwidgetUtil.saveWidgetInstanceTitleAndIcon(
			newWidgetId,
		 	com.ibm.mm.builder.utils.enablerUtil.getNodeTitle(widgetMD), 
		 	widgetMD.getIconURL(false)
		);
		
		// Fourth, add call back to update embedding dlg
		try{
			var wm = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(newWidgetId);
			this.embedWidgetDlg.widgetInstanceId = newWidgetId;
			if (wm && wm.loaded) {
				this.embedWidgetDlg.updateEmbedding();
			} else {
				var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
				eventService.subscribeEvent(com.ibm.mashups.iwidget.Constants.WIDGET_LOADED + "." + newWidgetId, this.embedWidgetDlg, "updateEmbedding");
			}			
		}catch(ex){
			console.log(ex);
		}			
	},
	
	onEmbedHubWidget: function(iEvent){
		// First, create a widget instance markup
		var widgetMap = iEvent.payload.hubWidgetPayload;
				
		var newWidgetId = com.ibm.mm.builder.utils.embedUtil.createEmbeddingHubWidgetMarkup(widgetMap);
		
		// Second, call live text to parse dom
		var widgetPlaceHolder = dojo.byId("Embedding_Widget_TmpDiv");
		//var widgetMD = com.ibm.mm.builder.utils.toolboxUtil.getWidgetDefinition(widgetDefId);
		
		dojo.publish("/com/ibm/mashups/livetext/livetextchanged",[widgetPlaceHolder]);
		
		if(!this.embedWidgetDlg.dialogContainer){
			if(typeof this.iContext.dialogContainer !== undefined && this.iContext.dialogContainer !== null){
				this.embedWidgetDlg.dialogContainer = this.iContext.dialogContainer;
				var originHideFunc = dojo.hitch(this.embedWidgetDlg.dialogContainer, this.embedWidgetDlg.dialogContainer.trueHide);
				var _this = this;
				this.embedWidgetDlg.dialogContainer.trueHide = dojo.hitch(this.embedWidgetDlg.dialogContainer, function(){
					originHideFunc();
					_this.embedWidgetDlg.destroyEmbeddedWidget();
				});		
			}	
		}
		
		// Third, update title and icon
		com.ibm.mm.builder.utils.iwidgetUtil.saveWidgetInstanceTitleAndIcon(
			newWidgetId,
			widgetMap.label,
			com.ibm.mashups.enabler.utils.EndpointHelper.resolve(widgetMap.icon)
		 	//com.ibm.mm.builder.utils.enablerUtil.getNodeTitle(widgetMD), 
		 	//widgetMD.getIconURL(false)
		);
		
		// Fourth, add call back to update embedding dlg
		try{
			var wm = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(newWidgetId);
			this.embedWidgetDlg.widgetInstanceId = newWidgetId;
			if (wm && wm.loaded) {
				this.embedWidgetDlg.updateEmbedding();
			} else {
				var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
				eventService.subscribeEvent(com.ibm.mashups.iwidget.Constants.WIDGET_LOADED + "." + newWidgetId, this.embedWidgetDlg, "updateEmbedding");
			}			
		}catch(ex){
			console.log(ex);
		}			
	}
});
